 _        = require('underscore');
Pir       = require("../server/adapters/pir").pir;
Afilias   = require("../server/adapters/afilias").afilias;
Verisign  = require("../server/adapters/verisign").verisign;
Ly        = require("../server/adapters/ly").ly;
Serverdef = require("../server").serverdef;

nicservers = {
  ".br.com": {nic: "whois.centralnic.net"},
  ".cn.com": {nic: "whois.centralnic.net"},
  ".de.com": {nic: "whois.centralnic.net"},
  ".eu.com": {nic: "whois.centralnic.net"},
  ".gb.com": {nic: "whois.centralnic.net"},
  ".gb.net": {nic: "whois.centralnic.net"},
  ".hu.com": {nic: "whois.centralnic.net"},
  ".no.com": {nic: "whois.centralnic.net"},
  ".qc.com": {nic: "whois.centralnic.net"},
  ".ru.com": {nic: "whois.centralnic.net"},
  ".sa.com": {nic: "whois.centralnic.net"},
  ".se.com": {nic: "whois.centralnic.net"},
  ".se.net": {nic: "whois.centralnic.net"},
  ".uk.com": {nic: "whois.centralnic.net"},
  ".uk.net": {nic: "whois.centralnic.net"},
  ".us.com": {nic: "whois.centralnic.net"},
  ".uy.com": {nic: "whois.centralnic.net"},
  ".za.com": {nic: "whois.centralnic.net"},
  ".jpn.com": {nic: "whois.centralnic.net"},
  ".web.com": {nic: "whois.centralnic.net"},
  ".com": {nic: "whois.crsnic.net", adapter: new Verisign},
  ".za.net": {nic: "whois.za.net"},
  ".net": {nic: "whois.crsnic.net", adapter: new Verisign},
  ".eu.org": {nic: "whois.eu.org"},
  ".za.org": {nic: "whois.za.org"},
  ".org": {nic: "whois.publicinterestregistry.net", adapter: new Pir},
  ".edu": {nic: "whois.educause.net"},
  ".gov": {nic: "whois.nic.gov"},
  ".int": {nic: "whois.iana.org"},
  ".e164.arpa": {nic: "whois.ripe.net"},
  ".arpa": {nic: "whois.iana.org"},
  ".aero": {nic: "whois.aero"},
  ".asia": {nic: "whois.nic.asia"},
  ".biz": {nic: "whois.nic.biz"},
  ".cat": {nic: "whois.cat"},
  ".coop": {nic: "whois.nic.coop"},
  ".info": {nic: "whois.afilias.info"},
  ".jobs": {nic: "jobswhois.verisign-grs.com", adapter: new Verisign},
  ".mobi": {nic: "whois.dotmobiregistry.net"},
  ".museum": {nic: "whois.museum"},
  ".name": {nic: "whois.nic.name"},
  ".pro": {nic: "whois.registrypro.pro"},
  ".tel": {nic: "whois.nic.tel"},
  ".travel": {nic: "whois.nic.travel"},
  ".ac": {nic: "whois.nic.ac"},
  ".ae": {nic: "whois.aeda.net.ae"},
  ".af": {nic: "whois.nic.af"},
  ".ag": {nic: "whois.nic.ag"},
  ".ai": {nic: "whois.ai"},
  ".am": {nic: "whois.nic.am"},
  ".as": {nic: "whois.nic.as"},
  ".priv.at": {nic: "whois.nic.priv.at"},
  ".at": {nic: "whois.nic.at"},
  ".au": {nic: "whois.ausregistry.net.au"},
  ".be": {nic: "whois.dns.be"},
  ".bg": {nic: "whois.register.bg"},
  ".bj": {nic: "whois.nic.bj"},
  ".br": {nic: "whois.nic.br"},
  ".bz": {nic: "whois.afilias-grs.info", adapter: new Afilias},
  ".co.ca": {nic: "whois.co.ca"},
  ".ca": {nic: "whois.cira.ca"},
  ".cc": {nic: "whois.nic.cc", adapter: new Verisign},
  ".cd": {nic: "whois.nic.cd"},
  ".ch": {nic: "whois.nic.ch"},
  ".ci": {nic: "www.nic.ci"},
  ".ck": {nic: "whois.nic.ck"},
  ".cl": {nic: "whois.nic.cl"},
  ".edu.cn": {nic: "whois.edu.cn"},
  ".cn": {nic: "whois.cnnic.cn"},
  ".uk.co": {nic: "whois.uk.co"},
  ".cx": {nic: "whois.nic.cx"},
  ".cz": {nic: "whois.nic.cz"},
  ".de": {nic: "whois.denic.de"},
  ".dk": {nic: "whois.dk-hostmaster.dk"},
  ".dm": {nic: "whois.nic.dm"},
  ".ee": {nic: "whois.eenet.ee"},
  ".eu": {nic: "whois.eu"},
  ".fi": {nic: "whois.ficora.fi"},
  ".fj": {nic: "whois.usp.ac.fj"},
  ".fo": {nic: "whois.ripe.net"},
  ".fr": {nic: "whois.nic.fr"},
  ".gd": {nic: "whois.adamsnames.tc"},
  ".gg": {nic: "whois.gg"},
  ".gi": {nic: "whois.afilias-grs.info", adapter: new Afilias},
  ".gl": {nic: "whois.nic.gl"},
  ".gm": {nic: "whois.ripe.net"},
  ".gp": {nic: "whois.nic.gp"},
  ".gs": {nic: "whois.nic.gs"},
  ".gy": {nic: "whois.registry.gy"},
  ".hk": {nic: "whois.hkdnr.net.hk"},
  ".hm": {nic: "whois.registry.hm"},
  ".hn": {nic: "whois.afilias-grs.info", adapter: new Afilias},
  ".ht": {nic: "whois.nic.ht"},
  ".hu": {nic: "whois.nic.hu"},
  ".id": {nic: "whois.pandi.or.id"},
  ".ie": {nic: "whois.domainregistry.ie"},
  ".il": {nic: "whois.isoc.org.il"},
  ".im": {nic: "whois.nic.im"},
  ".in": {nic: "whois.registry.in"},
  ".io": {nic: "whois.nic.io"},
  ".ir": {nic: "whois.nic.ir"},
  ".is": {nic: "whois.isnic.is"},
  ".it": {nic: "whois.nic.it"},
  ".je": {nic: "whois.je"},
  ".jp": {nic: "whois.jprs.jp"},
  ".ke": {nic: "whois.kenic.or.ke"},
  ".kg": {nic: "whois.domain.kg"},
  ".ki": {nic: "whois.nic.mu"},
  ".kp": {nic: "whois.kcce.kp"},
  ".kr": {nic: "whois.nic.or.kr"},
  ".kz": {nic: "whois.nic.kz"},
  ".la": {nic: "whois.nic.la"},
  ".lc": {nic: "whois.afilias-grs.info", adapter: new Afilias},
  ".li": {nic: "whois.nic.li"},
  ".lk": {nic: "whois.nic.lk"},
  ".lt": {nic: "whois.domreg.lt"},
  ".lu": {nic: "whois.dns.lu"},
  ".lv": {nic: "whois.nic.lv"},
  ".ly": {nic: "whois.nic.ly", adapter: new Ly},
  ".ma": {nic: "whois.iam.net.ma"},
  ".mc": {nic: "whois.ripe.net"},
  ".me": {nic: "whois.meregistry.net", adapter: new Pir},
  ".mg": {nic: "whois.nic.mg"},
  ".mn": {nic: "whois.afilias-grs.info", adapter: new Afilias},
  ".ms": {nic: "whois.nic.ms"},
  ".mu": {nic: "whois.nic.mu"},
  ".mx": {nic: "whois.nic.mx"},
  ".my": {nic: "whois.domainregistry.my"},
  ".na": {nic: "whois.na-nic.com.na"},
  ".nc": {nic: "whois.cctld.nc"},
  ".nf": {nic: "whois.nic.nf"},
  ".ng": {nic: "whois.register.net.ng"},
  ".nl": {nic: "whois.domain-registry.nl"},
  ".no": {nic: "whois.norid.no"},
  ".nu": {nic: "whois.nic.nu"},
  ".nz": {nic: "whois.srs.net.nz"},
  ".pe": {nic: "whois.nic.pe"},
  ".co.pl": {nic: "whois.co.pl"},
  ".pl": {nic: "whois.dns.pl"},
  ".pm": {nic: "whois.nic.fr"},
  ".pr": {nic: "whois.nic.pr"},
  ".pt": {nic: "whois.dns.pt"},
  ".re": {nic: "whois.nic.fr"},
  ".ro": {nic: "whois.rotld.ro"},
  ".edu.ru": {nic: "whois.informika.ru"},
  ".ru": {nic: "whois.ripn.net"},
  ".sa": {nic: "whois.nic.net.sa"},
  ".sb": {nic: "whois.coccaregistry.net"},
  ".sc": {nic: "whois.afilias-grs.info", adapter: new Afilias},
  ".se": {nic: "whois.nic-se.se"},
  ".sg": {nic: "whois.nic.net.sg"},
  ".sh": {nic: "whois.nic.sh"},
  ".si": {nic: "whois.arnes.si"},
  ".sk": {nic: "whois.sk-nic.sk"},
  ".sl": {nic: "whois.nic.sl"},
  ".sm": {nic: "whois.ripe.net"},
  ".sn": {nic: "whois.nic.sn"},
  ".st": {nic: "whois.nic.st"},
  ".su": {nic: "whois.ripn.net"},
  ".tc": {nic: "whois.adamsnames.tc"},
  ".tf": {nic: "whois.nic.tf"},
  ".th": {nic: "whois.thnic.net"},
  ".tk": {nic: "whois.dot.tk"},
  ".tl": {nic: "whois.nic.tl"},
  ".tm": {nic: "whois.nic.tm"},
  ".to": {nic: "whois.tonic.to"},
  ".tr": {nic: "whois.nic.tr"},
  ".tv": {nic: "whois.nic.tv", adapter: new Verisign},
  ".tw": {nic: "whois.twnic.net"},
  ".ua": {nic: "whois.net.ua"},
  ".ug": {nic: "www.registry.co.ug"},
  ".ac.uk": {nic: "whois.ja.net"},
  ".gov.uk": {nic: "whois.ja.net"},
  ".uk": {nic: "whois.nic.uk"},
  ".fed.us": {nic: "whois.nic.gov"},
  ".us": {nic: "whois.nic.us"},
  ".uy": {nic: "whois.nic.org.uy"},
  ".uz": {nic: "whois.cctld.uz"},
  ".va": {nic: "whois.ripe.net"},
  ".vc": {nic: "whois.afilias-grs.info", adapter: new Afilias},
  ".ve": {nic: "whois.nic.ve"},
  ".vg": {nic: "whois.adamsnames.tc"},
  ".wf": {nic: "whois.nic.fr"},
  ".ws": {nic: "whois.samoanic.ws"},
  ".yt": {nic: "whois.nic.fr"},
  ".ac.za": {nic: "whois.ac.za"},
  ".co.za": {nic: "whois.coza.net.za"},
  ".gov.za": {nic: "whois.gov.za"},
  ".xn--fiqs8s": {nic: "cwhois.cnnic.cn"},
  ".xn--fiqz9s": {nic: "cwhois.cnnic.cn"},
  ".xn--mgbaam7a8h": {nic: "whois.aeda.net.ae"},
  ".xn--mgberp4a5d4ar": {nic: "whois.nic.net.sa"},
  ".xn--wgbh1c": {nic: "whois.dotmasr.eg"},
  ".xn--p1ai": {nic: "whois.ripn.net"},
  "-dom": {nic: "whois.networksolutions.com"},
  "-org": {nic: "whois.networksolutions.com"},
  "-hst": {nic: "whois.networksolutions.com"},
  "-arin": {nic: "whois.arin.net"},
  "-ripe": {nic: "whois.ripe.net"},
  "-mnt": {nic: "whois.ripe.net"},
  "-lacnic": {nic: "whois.lacnic.net"},
  "-afrinic": {nic: "whois.afrinic.net"},
  "-ap": {nic: "whois.apnic.net"},
  "-ar": {nic: "whois.aunic.net"},
  "-cn": {nic: "whois.cnnic.net.cn"},
  "-cz": {nic: "whois.nic.cz"},
  "-dk": {nic: "whois.dk-hostmaster.dk"},
  "-il": {nic: "whois.isoc.org.il"},
  "-is": {nic: "whois.isnic.is"},
  "-kg": {nic: "whois.domain.kg"},
  "-ti": {nic: "whois.telstra.net"},
  "-tw": {nic: "whois.twnic.net"},
  "-6bone": {nic: "whois.6bone.net"},
  "-coop": {nic: "whois.nic.coop"},
  "-cknic": {nic: "whois.nic.ck"},
  "-idnic": {nic: "whois.idnic.net.id"},
  "-itnic": {nic: "whois.nic.it"},
  "-frnic": {nic: "whois.nic.fr"},
  "-gandi": {nic: "whois.gandi.net"},
  "-kenic": {nic: "whois.kenic.or.ke"},
  "-lrms": {nic: "whois.afilias.info"},
  "-metu": {nic: "whois.metu.edu.tr"},
  "-nicat": {nic: "whois.nic.at"},
  "-nicir": {nic: "whois.nic.ir"},
  "-norid": {nic: "whois.norid.no"},
  "-ripn": {nic: "whois.ripn.net"},
  "-rotld": {nic: "whois.rotld.ro"},
  "-sgnic": {nic: "whois.nic.net.sg"},
  "-tel": {nic: "whois.nic.tel"},
  "-uanic": {nic: "whois.com.ua"},
  "-uynic": {nic: "www.rau.edu.uy"},
  "-sixxs": {nic: "whois.sixxs.net"},
}

_.each(nicservers, function(value, key) {
    Serverdef.define_tld(key, value.nic, value.adapter);
});
